/* keymap.h */

#ifndef KEYMAP_H_
#define KEYMAP_H_

#include "tree.h"


typedef struct Keycommand Keycommand;
struct Keycommand {
    int inuse;
    Node *tree;
};

#define KEYMAP_SIZE	(256+0x20) /* 0x20 for mouse */

typedef struct Keymap_entry Keymap [KEYMAP_SIZE];
struct Keymap_entry {
    Keymap *keymap;
    Keycommand *kc;
};

extern Keymap *the_keymap;

extern void init_keymap ();

extern void free_pending_kcs ();
extern Keymap *new_keymap ();
extern void free_keymap ();
extern void add_keymap_entry ();
extern void delete_keymap_entry ();
extern int walk_keymap ();

#endif /* KEYMAP_H_ */

