/* lex.h */

#ifndef LEX_H_
#define LEX_H_

#include <stdio.h>
#include "mem.h"

#define MAXPUSH 10

typedef struct Stream Stream;
struct Stream {
    Stream *next;
    int	lineno;
    int	charno;
    int pushpos;
    int prompt2;
    unsigned char pushed [MAXPUSH];
    int prevchar;
    int prevlen;
    int eofmet;
    int (*getter)();

    int	type;					/* 0:file 1:string 2:readline*/
    FILE *file;
    unsigned char *string;
    unsigned char *string_orig;
};


extern Stream *l_stream;
extern void l_popstream ();
extern void l_setinput_file ();
extern void l_setinput_string ();
extern void l_setinput_readline ();
extern void init_readline ();
extern void init_yylex ();
extern void reset_yylex ();
extern int yylex ();
extern void yyerror ();
extern void set_prompt1 ();

#endif /* LEX_H_ */

