/* mem.h */

#ifndef MEM_H_
#define MEM_H_

#include "config.h"

#ifdef VOID_MEMCPY
 extern void *memcpy ();
 extern void *memset ();
#else
 extern char *memcpy ();
 extern char *memset ();
#endif

#ifdef NORINDEX
# define rindex strrchr
#endif
extern char *rindex ();

#ifndef NULL
# define NULL 0
#endif






#define STREQ(a,b)	(*(unsigned char *)(a) == *(unsigned char *)(b) && strcmp (a,b) == 0)

#define New(type)	((type *) mmalloc (sizeof (type)))


extern char *mmalloc ();
extern void mfree ();
extern char *mrealloc ();
extern char *mstrdup ();


/*
 * Stack allocator.  Stack should be an opaque type.
 */

typedef struct Stackblock Stackblock;
struct Stackblock {
    Stackblock *next;
    char *mem;
    long size;
};

typedef struct Stack Stack;
struct Stack {
    Stack *next;
    Stackblock *block;
    long pos;
};

#define SNew(stack,type)	((type *) smalloc (stack, sizeof (type)))

extern char *smalloc ();
extern Stack *push_stack ();
extern Stack *pop_stack ();
extern Stack *create_stack ();
extern void destroy_stack ();

extern char *sstrdup ();

#endif /* MEM_H_ */
