/* scrio.h */

#ifndef SCRIO_H_
#define SCRIO_H_

#ifdef CURSESX /* for vax */
# include <cursesX.h>
#else
# include <curses.h>
#endif

#ifndef wrefresh
 extern int wrefresh (); /* can't they do correct header files ? */
#endif
#ifndef werase
 extern int werase ();
#endif
#ifndef wmove
 extern int wmove ();
#endif
#ifndef wclrtoeol
 extern int wclrtoeol ();
#endif
#ifndef waddstr
 extern int waddstr ();
#endif
#ifndef wdeleteln
 extern int wdeleteln ();
#endif
#ifndef winsertln
 extern int winsertln ();
#endif
#ifndef waddch
 extern int waddch ();
#endif
#ifndef wdelch
 extern int wdelch ();
#endif
#ifndef winsch
 extern int winsch ();
#endif
#ifndef delwin
 extern int delwin ();
#endif
#ifndef endwin
 extern int endwin ();
#endif


#ifdef OLDCURSES
# undef NEWCURSES
#else
# ifdef A_BOLD
#  define NEWCURSES
# endif
#endif


extern int cols, lines;
extern int minishelllines;
extern int newminilines;
extern int in_screen;
extern int is_xterm;
extern int want_mouse;
extern int slow_mouse;
extern int mouse_on;
extern int flag_beep;

extern WINDOW *mainw, *menuw;

extern int sigint;

extern void init_tty ();
extern void stty_original ();
extern void stty_getchar ();
extern void stty_running ();

extern void init_specialvars ();
extern void set_mouse_on ();
extern void set_mouse_off ();

extern void init_scr ();
extern void exit_scr ();
extern void get_scr_size ();
extern void beep ();

extern void init_keys ();
extern void unget_key ();
extern int get_key ();
extern int key_pressed ();
extern void unget_key ();
extern void clear_key_buffer ();

extern int sig_winch_pend;
extern int sig_winch_ok;
extern void (*sig_winch_routine) ();

#endif	/* SCRIO_H_ */
