/* tree.h */

#ifndef TREE_H_
#define TREE_H_


typedef enum Nodetype {
    nCmd,	/* p p */	/* (cmds,cmds) */
    nFn,	/* p p */	/* define a function */
    nMap,	/* p p */	/* keyseq, body */
    nArgs,	/* p p */	/* (args/arg,args/arg) : args */
    nWord,	/* s */		/* simple word */
    nVar,	/* p */		/* $var */
    nVarsub,	/* p p */	/* $var(1 2 8) */
    nCount,	/* p */		/* $#var */
    nFlat,	/* p */		/* $^var */
    nBackq,	/* p p */	/* `{stuff} or `"ifs"{stuff}*/
    nConcat,	/* p p */	/* (word list,word) : word */
    nArith,	/* p */		/* [ stuff ] */
    nAdd,	/* p p */
    nSub,	/* p p */
    nMul,	/* p p */
    nDiv,	/* p p */
    nEq,	/* p p */
    nNeq,	/* p p */
    nLt,	/* p p */
    nLe,	/* p p */
    nGt,	/* p p */
    nGe,	/* p p */
    nAndand,	/* p p */
    nOror,	/* p p */
    nSetvar,	/* p p */
    nIf,	/* p p p */
    nWhile,	/* p p */
    nLocal,	/* p p */
    nBrace,	/* p */
    nReturn,	/* p */
    nBreak,	/* p */
    nFor,	/* p p p */
    nVoid,	/* p */
    nCatch,	/* p */
    /* more to come... */
} Nodetype;


typedef struct Node Node;
struct Node {
    Nodetype type;
    union {
	char *s;
	int i;
	Node *p;
    } u[4];
};


extern Node *mknode ();
extern Node *mkappend ();

extern Node *copy_tree ();
extern void free_tree ();

extern void print_tree ();

#endif /* TREE_H_ */
