/* util.h */

#include <unistd.h>

#include "mem.h"
#include "commands.h"




char *string_from_long (i) /* result in a static area */
    long i;
{
#define BUFSZ 20
    static char buf [BUFSZ];
    int pos;
    int s;

    if (i == 0)
	return "0";
    if (i == 0x80000000)
	return "-2147483648";
    pos = BUFSZ;
    buf [--pos] = '\0';
    if (i < 0) {
	s = 1;
	i = -i;
    } else
	s = 0;
    while (i != 0) {
	buf [--pos] = '0'+ (i%10);
	i /= 10;
    }
    if (s)
	buf [--pos] = '-';
    return buf+pos;
}

char *sstring_from_long (i)
    long i;
{
    char *string = string_from_long (i);
    int len = strlen (string) + 1;
    char *mem = smalloc (command_stack, len);
    memcpy (mem, string, len);
    return mem;
}




long long_from_string (s, longp)
    char *s;
    long *longp;
{
    long i;
    char c;
    int sgn;

    c = *s++;
    if (c == '\0')
	return -1;
    if (c == '-') {
	sgn = -1;
	c = *s++;
    } else
	sgn = 1;
    i = 0;
    do {
	if (c < '0' || c > '9')
	    return -1;
	i = 10*i + (c-'0');
	c = *s++;
    } while (c != '\0');
    *longp = sgn*i;
    return 0;
}


int ulong_from_string (s)
    char *s;
{
    long res;
    if (long_from_string (s, &res))
	return -1;
    if (res < 0)
	return -1;
    return res;
}


int fd_safe (fd)          /* returns the same descriptor, but not in 0, 1, 2 */
    int fd;
{	
    int f [3];
    int nf = 0;

    while (fd >= 0 && fd <= 2) {
        f [nf++] = fd;
        fd = dup (fd);
    }
    while (nf)
        close (f [--nf]);
    return fd;
}
